<%@ page import="patenter.*" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<%!
	protected String booleanToCheckBox(boolean value, String id)
	{
		return String.format("<input type='checkbox' name='%s' id='%s' %s value='true'/>", id, id, value ? "checked='checked'" : "");
	}
	
	protected String stringToTextBox(String value, String id)
	{
		return String.format("<input type='text' name='%s' id='%s' value='%s' />", id, id, value);
	}

%>
<html>
	<head>
		<title>Patentomatic</title>
		<link rel="stylesheet" type="text/css" href="/styles.css" />
		<script type="text/javascript" src="/jquery-1.6.4.min.js" language="javascript"></script> 
		<script type="text/javascript" src="/index.js" language="javascript"></script> 
	</head>
	<body>
		<div id="header">
			Patentomatic: The best thing since sliced bread and Starcraft II
		</div>
		<div id="main">
			<form method="post" enctype="multipart/form-data" action="/jsp/upload.jsp" id="main_form">
				<label for="pdf_file">Drawings file (.pdf): </label>
				<input type="file" id="pdf_file" name="pdf_file" size="100" /> <br />
				
				<label for="word_file">Specification file (.doc or .docx): </label>
				<input type="file" id="word_file" name="word_file" size="100" /> <br />
				
				<label for="blacklist_file">Blacklist hashes file: </label>
				<input type="file" id="blacklist_file" name="blacklist_file" size="100" /><br />

				<label for="langrules_file">Supplemental language rules file: </label>
				<input type="file" id="langrules_file" name="langrules_file" size="100" /><br />

				<div id="options">
					<fieldset class="options_container">
						<% 
							PatenterOptions options = new PatenterOptions();
						%>
						
						<div class="fieldset_title">Options</div>
						
						<div class="option_container">
							<label for="satisfy_generics_particulars">Satisfy Generic references by particulars</label>
							<%= booleanToCheckBox(options.getSatisfyGenericsByParticulars(), "satisfy_generics_particulars") %>  <br />
						</div>
							
						<div class="option_container">							
							<label for="parse_drawing_numbers_preamble">Parse Drawing numbers in the preamble</label>
							<%= booleanToCheckBox(options.getParseDrawingNumbersInPreamble(), "parse_drawing_numbers_preamble") %>  <br />
						</div>
							
						<div class="option_container">						
							<label for="satisfy_particulars_view">Satisfy projection references by views</label>
							<%= booleanToCheckBox(options.getSatisfyParticularsByViews(), "satisfy_particulars_view") %>  <br />
						</div>

						<div class="option_container">						
							<label for="check_font_sizes">Check font sizes</label>
							<%= booleanToCheckBox(options.getCheckFontSizes(), "check_font_sizes") %>  <br />
						</div>

						<div class="option_container">						
							<label for="check_drawings_orientations">Check drawings orientations</label>
							<%= booleanToCheckBox(options.getCheckDrawingsOrientations(), "check_drawings_orientations") %>  <br />
						</div>
						
						<div class="option_container">						
							<label for="pdf_password">PDF password (blank for none)</label>
							<%= stringToTextBox(options.getPDFPassword(), "pdf_password") %>  <br />
						</div>
						
						<div class="option_container">						
							<label for="min_font_height">Minimum font height (inch)</label>
							<%= stringToTextBox(new Double(options.getMinimumFontHeight()).toString(), "min_font_height") %>  <br />
						</div>
						
						<div class="option_container">
							<label for="check_language_rules">Check Language Rules</label>
							<%= booleanToCheckBox(true, "check_language_rules") %>  <br />
						</div>

						<div class="option_container">
							<label for="check_spacing_rules">Check Spacing Rules</label>
							<%= booleanToCheckBox(options.getCheckSpacingRules(), "check_spacing_rules") %>  <br />
						</div>
						<div class="option_container">
							<label for="check_page_margins">Check Spacing Rules</label>
							<%= booleanToCheckBox(options.getCheckPageMargins(), "check_page_margins") %>  <br />
						</div>
					</fieldset>
				</div>
				
				<center><input type="submit" id="submit_form" value="Submit!" /></center>
			</form>
		</div>
		<div id="footer">
			Patentomatic (c) 2011 by Monolithic3D
		</div>
	</body>
</html>
