<%@ page import="org.apache.commons.fileupload.*, org.apache.commons.fileupload.servlet.*, org.apache.commons.fileupload.disk.*, org.apache.commons.io.*, java.util.*, java.io.*, web.jsp.*, patenter.*, patenter.parsers.* " %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<%!
	int requestId = -1;
	
	protected void enqueueRequest(String prefix, Map<String, UploadDataInfo> fields, PatenterOptions options)
	{
		this.requestId = TaskManager.enqueueRequest(prefix, fields, options);
	}
	
	protected boolean parseBoolean(String paramValue)
	{
		if (paramValue == null)
			return false;
		return paramValue.equals("true");
	}
	
	protected String map2string(Map map)
	{
		StringBuilder bld = new StringBuilder();
		bld.append("[\n");
		for(Object key:map.keySet())
			bld.append(String.format("%s => %s\n", key.toString(), map.get(key).toString()));
		bld.append("]\n");
		return bld.toString();
	}
%>

<html>
	<head>
		<link rel="stylesheet" type="text/css" href="/styles.css" />
		<script type="text/javascript" src="/jquery-1.6.4.min.js" language="javascript"></script> 
		<script type="text/javascript" src="/upload.js" language="javascript"></script> 
	</head>
	<body>
	<%
		try
		{
			//PatenterOptions patenterOptions = new PatenterOptions();
			HashMap<String, String> mp = new HashMap<String, String>();
			if (ServletFileUpload.isMultipartContent(request))
			{
				File requestDirectory = patenter.Patenter.createUniqueFile("requests_", "");
				requestDirectory.mkdirs();
				String requestPrefix = requestDirectory.getCanonicalPath() + "/";
				//out.println("canonicalpath: " + requestPrefix);
				
				Map<String, UploadDataInfo> fields = new HashMap<String, UploadDataInfo>();
			
				ServletFileUpload servletFileUpload = new ServletFileUpload(new DiskFileItemFactory());
				List fileItemsList = servletFileUpload.parseRequest(request);

				String optionalFileName = "";
				FileItem fileItem = null;

				Iterator it = fileItemsList.iterator();
				while (it.hasNext())
				{
					FileItem fileItemTemp = (FileItem)it.next();
					if (fileItemTemp.isFormField())
						mp.put(fileItemTemp.getFieldName(), fileItemTemp.getString());
					//out.println(fileItemTemp.getFieldName());
					UploadDataInfo fieldInfo = new UploadDataInfo(requestPrefix, fileItemTemp);
					if (!fieldInfo.isRelevant())
						continue;					
					fields.put(fileItemTemp.getFieldName(), fieldInfo);
					//out.println(String.format("field is: %s, type: %d, is file: %b", fileItemTemp.getName(), fieldInfo.getType(), fieldInfo.isFile()));
					if (fieldInfo.isFile())
					{
						//out.println(String.format("accepted file: %s, size: %d <br />\n", fileItemTemp.getName(), fieldInfo.getFile().length()));
					}
				}
				
				//System.out.println(map2string(mp));
			
				boolean satisfyGenericsByParticulars = parseBoolean(mp.get("satisfy_generics_particulars"));
				boolean parse_drawing_numbers_preamble = parseBoolean(mp.get("parse_drawing_numbers_preamble"));
				boolean satisfy_particulars_view = parseBoolean(mp.get("satisfy_particulars_view"));
				boolean checkDrawingsOrientations = parseBoolean(mp.get("check_drawings_orientations"));
				boolean checkFontSizes = parseBoolean(mp.get("check_font_sizes"));
				String pdf_password = mp.get("pdf_password");
				double min_font_height = Double.parseDouble(mp.get("min_font_height"));
				boolean checkLanguageRules = parseBoolean(mp.get("check_language_rules"));
				boolean checkSpacingRules = parseBoolean(mp.get("check_spacing_rules"));
				boolean checkPageMargins = parseBoolean(mp.get("check_page_margins"));
				
				//out.println("m1");
				File langRulesFile = fields.containsKey("langrules_file") ? fields.get("langrules_file").getFile() : null;
				Collection<ForbiddenTextRule> forbTextRules = PatenterOptions.buildForbiddenTextRules(checkLanguageRules, langRulesFile);
				//out.println("m2");
				PatenterOptions patenterOptions = new PatenterOptions(satisfyGenericsByParticulars, parse_drawing_numbers_preamble, satisfy_particulars_view, 
													pdf_password, min_font_height, checkDrawingsOrientations, checkFontSizes,
													forbTextRules, checkSpacingRules, checkPageMargins);
				//out.println("m3");
				//System.out.println("options: " + patenterOptions.toString());
				
				enqueueRequest(requestPrefix, fields, patenterOptions);				
			}
			else
				throw new RuntimeException("invalid request");
		}
		catch(Exception e)
		{
			e.printStackTrace();
			out.println(e.toString());
			return;
		}
%>
		<!-- Press <a href="/view.jsp?id=<%= this.requestId %>">here</a> to view results -->
		<script type="text/javascript">
			var request_id = <%= this.requestId %>
			var ajax_interval = setInterval(seeProgress, 250, request_id);
			function stopAjax()
			{
				clearInterval(ajax_interval);
			}
		</script>
		<div id="header">
			Patentomatic: The best thing since sliced bread and Starcraft II
		</div>
		
		<div id="main">
			<div id="status">
				
			</div>
		</div>
		
		<div id="footer">
			Patentomatic (c) 2011 by Monolithic3D
		</div>
	</body>
</html>
